# -*- mode: ruby -*-
# vi: set ft=ruby :

Vagrant.configure("2") do |config|
    # Base VM OS configuration.
    config.vm.box = "ubuntu/bionic64"
    config.ssh.insert_key = false
    config.vm.synced_folder '.', '/vagrant', disabled: true
    
  
    config.vm.provider :virtualbox do |v|
      v.memory = 512
      v.cpus = 1
      v.linked_clone = true
    end
  
    # Define three VMs with static private IP addresses.
    boxes = [
      { :name => "loadbalancer", :ip => "192.168.4.2" },
      { :name => "app1server", :ip => "192.168.4.3" },
      { :name => "app2server", :ip => "192.168.4.4" }
      #{ :name => "dbserver", :ip => "192.168.4.5" }
    ]
  
    # Provision each of the VMs.
    boxes.each do |opts|
      config.vm.define opts[:name] do |config|
        config.vm.hostname = opts[:name]
        config.vm.network :private_network, ip: opts[:ip]
  
        # Provision all the VMs using Ansible after last VM is up.
        if opts[:name] == "app2server"
          config.vm.provision "ansible" do |ansible|
            ansible.playbook = "playbooks/provision.yml"
            ansible.inventory_path = "inventory"
            ansible.limit = "all"
          end
        end
      end
    end
  
  end